unit EvBFileFormatAIC;
{ File format filter for reading and writing Advanced Image Coding (AIC) files }

interface

uses
  EvBGraphics, Classes;

type
  TEvBAICFileFormat = class(TEvBBitmapFileFormat)
  { File format filter for reading and writing Advanced Image Coding (AIC) files.
    Uses the experimental AIC library. }
  public
    procedure ReadStream(const Stream: TStream); override;
    procedure WriteStream(const Stream: TStream); override;
  end;

implementation

uses
  AICEncoder, AICDecoder;

const
  AICMagic = 'AIC';

{ TEvBAICFileFormat }

procedure TEvBAICFileFormat.ReadStream(const Stream: TStream);
begin
  inherited;
  TAICDecoder.Expand(Stream,Bitmap);
end;

procedure TEvBAICFileFormat.WriteStream(const Stream: TStream);
begin
  inherited;
  TAICEncoder.Compress(Bitmap,Stream,Quality);
end;

initialization
  TEvBBitmap.RegisterFileFormat('Advanced Image Coding','.aic',AICMagic,TEvBAICFileFormat,True);

end.
