unit LibJPEG;
{ Quick, dirty and ugly conversion of some header files of the IJG JPEG library.
  Only those declarations needed by the Advanced Image Coding application
  are converted.

  Based on the IJG JPEG library version 6b }

interface

{$ALIGN 8}       // Align 8-byte data types on 8-byte boundaries
{$MINENUMSIZE 4} // Enumerations are 4 bytes minimum

type
  J_MESSAGE_CODE = (
    JMSG_NOMESSAGE,
    JERR_ARITH_NOTIMPL,
    JERR_BAD_ALIGN_TYPE,
    JERR_BAD_ALLOC_CHUNK,
    JERR_BAD_BUFFER_MODE,
    JERR_BAD_COMPONENT_ID,
    JERR_BAD_DCT_COEF,
    JERR_BAD_DCTSIZE,
    ERR_BAD_HUFF_TABLE,
    ERR_BAD_IN_COLORSPACE,
    JERR_BAD_J_COLORSPACE,
    JERR_BAD_LENGTH,
    JERR_BAD_LIB_VERSION,
    JERR_BAD_MCU_SIZE,
    JERR_BAD_POOL_ID,
    JERR_BAD_PRECISION,
    JERR_BAD_PROGRESSION,
    JERR_BAD_PROG_SCRIPT,
    JERR_BAD_SAMPLING, 
    JERR_BAD_SCAN_SCRIPT, 
    JERR_BAD_STATE, 
    JERR_BAD_STRUCT_SIZE,
    JERR_BAD_VIRTUAL_ACCESS, 
    JERR_BUFFER_SIZE, 
    JERR_CANT_SUSPEND, 
    JERR_CCIR601_NOTIMPL, 
    JERR_COMPONENT_COUNT, 
    JERR_CONVERSION_NOTIMPL, 
    JERR_DAC_INDEX,
    JERR_DAC_VALUE,
    JERR_DHT_INDEX, 
    JERR_DQT_INDEX, 
    JERR_EMPTY_IMAGE, 
    JERR_EMS_READ,
    JERR_EMS_WRITE, 
    JERR_EOI_EXPECTED, 
    JERR_FILE_READ, 
    JERR_FILE_WRITE, 
    JERR_FRACT_SAMPLE_NOTIMPL, 
    JERR_HUFF_CLEN_OVERFLOW, 
    JERR_HUFF_MISSING_CODE, 
    JERR_IMAGE_TOO_BIG, 
    JERR_INPUT_EMPTY, 
    JERR_INPUT_EOF, 
    JERR_MISMATCHED_QUANT_TABLE,
    JERR_MISSING_DATA, 
    JERR_MODE_CHANGE, 
    JERR_NOTIMPL, 
    JERR_NOT_COMPILED, 
    JERR_NO_BACKING_STORE, 
    JERR_NO_HUFF_TABLE,
    JERR_NO_IMAGE, 
    JERR_NO_QUANT_TABLE, 
    JERR_NO_SOI, 
    JERR_OUT_OF_MEMORY, 
    JERR_QUANT_COMPONENTS,
    JERR_QUANT_FEW_COLORS, 
    JERR_QUANT_MANY_COLORS, 
    JERR_SOF_DUPLICATE, 
    JERR_SOF_NO_SOS, 
    JERR_SOF_UNSUPPORTED, 
    JERR_SOI_DUPLICATE, 
    JERR_SOS_NO_SOF, 
    JERR_TFILE_CREATE, 
    JERR_TFILE_READ, 
    JERR_TFILE_SEEK,
    JERR_TFILE_WRITE,
    JERR_TOO_LITTLE_DATA, 
    JERR_UNKNOWN_MARKER, 
    JERR_VIRTUAL_BUG, 
    JERR_WIDTH_OVERFLOW, 
    JERR_XMS_READ, 
    JERR_XMS_WRITE, 
    JMSG_COPYRIGHT,
    JMSG_VERSION,
    JTRC_16BIT_TABLES,
    JTRC_ADOBE,
    JTRC_APP0, 
    JTRC_APP14, 
    JTRC_DAC, 
    JTRC_DHT, 
    JTRC_DQT, 
    JTRC_DRI, 
    JTRC_EMS_CLOSE, 
    JTRC_EMS_OPEN, 
    JTRC_EOI, 
    JTRC_HUFFBITS, 
    JTRC_JFIF, 
    JTRC_JFIF_BADTHUMBNAILSIZE,
    JTRC_JFIF_EXTENSION,
    JTRC_JFIF_THUMBNAIL, 
    JTRC_MISC_MARKER, 
    JTRC_PARMLESS_MARKER, 
    JTRC_QUANTVALS, 
    JTRC_QUANT_3_NCOLORS, 
    JTRC_QUANT_NCOLORS, 
    JTRC_QUANT_SELECTED, 
    JTRC_RECOVERY_ACTION, 
    JTRC_RST, 
    JTRC_SMOOTH_NOTIMPL,
    JTRC_SOF, 
    JTRC_SOF_COMPONENT, 
    JTRC_SOI,
    JTRC_SOS,
    JTRC_SOS_COMPONENT,
    JTRC_SOS_PARAMS,
    JTRC_TFILE_CLOSE,
    JTRC_TFILE_OPEN,
    JTRC_THUMB_JPEG,
    JTRC_THUMB_PALETTE,
    JTRC_THUMB_RGB,
    JTRC_UNKNOWN_IDS,
    JTRC_XMS_CLOSE,
    JTRC_XMS_OPEN,
    JWRN_ADOBE_XFORM,
    JWRN_BOGUS_PROGRESSION,
    JWRN_EXTRANEOUS_DATA,
    JWRN_HIT_MARKER,
    JWRN_HUFF_BAD_CODE,
    JWRN_JFIF_MAJOR,
    JWRN_JPEG_EOF,
    JWRN_MUST_RESYNC,
    JWRN_NOT_SEQUENTIAL,
    JWRN_TOO_MUCH_DATA
  );

const
  DCTSIZE = 8;
  DCTSIZE2 = 64;
  NUM_QUANT_TBLS = 4;
  NUM_HUFF_TBLS = 4;
  NUM_ARITH_TBLS = 16;
  MAX_COMPS_IN_SCAN = 4;
  C_MAX_BLOCKS_IN_MCU = 10;
  D_MAX_BLOCKS_IN_MCU = 10;
  JMSG_LENGTH_MAX = 200;	(* recommended size of format_message buffer *)
  JMSG_STR_PARM_MAX = 80;
  JPEG_LIB_VERSION = 62;

const
  JPOOL_PERMANENT	= 0;
  JPOOL_IMAGE	= 1;
  JPOOL_NUMPOOLS = 2;

const
  JPEG_RST0	= $D0;	// RST0 marker code
  JPEG_EOI	= $D9;	// EOI marker code
  JPEG_APP0	= $E0;	// APP0 marker code
  JPEG_COM	= $FE;	// COM marker code

type
  int = Integer;
  uint = Cardinal;
  long = Longint;
  pint = ^int;
  size_t = uint;
  UINT8 = Byte;
  UINT16 = Word;
//  Boolean = Longbool;

  JDIMENSION = uint;
  JSAMPLE = Byte;
  JSAMPROW = ^JSAMPLE;
  JSAMPARRAY = ^JSAMPROW;
  JSAMPIMAGE = ^JSAMPARRAY;
  JOCTET = Byte;

  PJSAMPLE = ^JSAMPLE;
  PJOCTET = ^JOCTET;

  JMETHOD = procedure; cdecl;

  J_COLOR_SPACE = (
    JCS_UNKNOWN,		(* error/unspecified *)
    JCS_GRAYSCALE,		(* monochrome *)
    JCS_RGB,		(* red/green/blue *)
    JCS_YCbCr,		(* Y/Cb/Cr (also known as YUV) *)
    JCS_CMYK,		(* C/M/Y/K *)
    JCS_YCCK);		(* Y/Cb/Cr/K *)
  J_DCT_METHOD = (
    JDCT_ISLOW,		(* slow but accurate integer algorithm *)
    JDCT_IFAST,		(* faster, less accurate integer method *)
    JDCT_FLOAT);		(* floating-point: accurate, fast on fast HW *)
  J_DITHER_MODE = (
    JDITHER_NONE,		(* no dithering *)
    JDITHER_ORDERED,	(* simple ordered dither *)
    JDITHER_FS);		(* Floyd-Steinberg error diffusion dither *)

type
  pjpeg_error_mgr = ^jpeg_error_mgr;
  pjpeg_memory_mgr = ^jpeg_memory_mgr;
  pjpeg_progress_mgr = Pointer;
  pjpeg_source_mgr = ^jpeg_source_mgr;
  pjpeg_component_info = Pointer;
  pjpeg_decomp_master = Pointer;
  pjpeg_d_main_controller = Pointer;
  pjpeg_d_coef_controller = Pointer;
  pjpeg_d_post_controller = Pointer;
  pjpeg_input_controller = Pointer;
  pjpeg_marker_reader = Pointer;
  pjpeg_entropy_decoder = Pointer;
  pjpeg_inverse_dct = Pointer;
  pjpeg_upsampler = Pointer;
  pjpeg_color_deconverter = Pointer;
  pjpeg_color_quantizer = Pointer;
  pjpeg_destination_mgr = ^jpeg_destination_mgr;
  pjpeg_scan_info = ^jpeg_scan_info;
  pjpeg_comp_master = Pointer;
  pjpeg_c_main_controller = Pointer;
  pjpeg_c_prep_controller = Pointer;
  pjpeg_c_coef_controller = Pointer;
  pjpeg_marker_writer = Pointer;
  pjpeg_color_converter = Pointer;
  pjpeg_downsampler = Pointer;
  pjpeg_forward_dct = Pointer;
  pjpeg_entropy_encoder = Pointer;

  PJQUANT_TBL = Pointer;
  PJHUFF_TBL = Pointer;

  jpeg_saved_marker_ptr = Pointer;
  j_common_ptr = ^jpeg_common_struct;
  j_decompress_ptr = ^jpeg_decompress_struct;

  jpeg_common_struct = record
    err: pjpeg_error_mgr;	(* Error handler module *)
    mem: pjpeg_memory_mgr;	(* Memory manager module *)
    progress: pjpeg_progress_mgr; (* Progress monitor, or NULL if none *)
    client_data: Pointer;		(* Available for use by application *)
    is_decompressor: Boolean;	(* So common code can tell which is which *)
    global_state: int;		(* For checking call sequence validity *)
  end;

  tcoef_bits = array [0..DCTSIZE2-1] of pint;
  pcoef_bits = ^tcoef_bits;

  pjpeg_decompress_struct = ^jpeg_decompress_struct;
  jpeg_decompress_struct = record
    err: pjpeg_error_mgr;	(* Error handler module *)
    mem: pjpeg_memory_mgr;	(* Memory manager module *)
    progress: pjpeg_progress_mgr; (* Progress monitor, or NULL if none *)
    client_data: Pointer;		(* Available for use by application *)
    is_decompressor: Boolean;	(* So common code can tell which is which *)
    global_state: int;		(* For checking call sequence validity *)

    (* Source of compressed data *)
    src: pjpeg_source_mgr;

    (* Basic description of image --- filled in by jpeg_read_header(). *)
    (* Application may inspect these values to decide how to process image. *)

    image_width: JDIMENSION;	(* nominal image width (from SOF marker) *)
    image_height: JDIMENSION;	(* nominal image height *)
    num_components: int;		(* # of color components in JPEG image *)
    jpeg_color_space: J_COLOR_SPACE; (* colorspace of JPEG image *)

    (* Decompression processing parameters --- these fields must be set before
     * calling jpeg_start_decompress().  Note that jpeg_read_header() initializes
     * them to default values.
     *)

    out_color_space: J_COLOR_SPACE; (* colorspace for output *)

    scale_num, scale_denom: uint; (* fraction by which to scale image *)

    output_gamma: double;		(* image gamma wanted in output *)

    buffered_image: boolean;	(* TRUE=multiple output passes *)
    raw_data_out: boolean ;		(* TRUE=downsampled data wanted *)

    dct_method: J_DCT_METHOD ;	(* IDCT algorithm selector *)
    do_fancy_upsampling: boolean ;	(* TRUE=apply fancy upsampling *)
    do_block_smoothing: boolean ;	(* TRUE=apply interblock smoothing *)

    quantize_colors: boolean ;	(* TRUE=colormapped output wanted *)
    (* the following are ignored if not quantize_colors: *)
    dither_mode: J_DITHER_MODE ;	(* type of color dithering to use *)
    two_pass_quantize: boolean ;	(* TRUE=use two-pass color quantization *)
    desired_number_of_colors: int ;	(* max # colors to use in created colormap *)
    (* these are significant only in buffered-image mode: *)
    enable_1pass_quant: boolean ;	(* enable future use of 1-pass quantizer *)
    enable_external_quant: boolean ;(* enable future use of external colormap *)
    enable_2pass_quant: boolean ;	(* enable future use of 2-pass quantizer *)

    (* Description of actual output image that will be returned to application.
     * These fields are computed by jpeg_start_decompress().
     * You can also use jpeg_calc_output_dimensions() to determine these values
     * in advance of calling jpeg_start_decompress().
     *)

    output_width: JDIMENSION ;	(* scaled image width *)
    output_height: JDIMENSION ;	(* scaled image height *)
    out_color_components: int ;	(* # of color components in out_color_space *)
    output_components: int ;	(* # of color components returned *)
    (* output_components is 1 (a colormap index) when quantizing colors;
     * otherwise it equals out_color_components.
     *)
    rec_outbuf_height: int ;	(* min recommended height of scanline buffer *)
    (* If the buffer passed to jpeg_read_scanlines() is less than this many rows
     * high, space and time will be wasted due to unnecessary data copying.
     * Usually rec_outbuf_height will be 1 or 2, at most 4.
     *)

    (* When quantizing colors, the output colormap is described by these fields.
     * The application can supply a colormap by setting colormap non-NULL before
     * calling jpeg_start_decompress; otherwise a colormap is created during
     * jpeg_start_decompress or jpeg_start_output.
     * The map has out_color_components rows and actual_number_of_colors columns.
     *)
    actual_number_of_colors: int ;	(* number of entries in use *)
    colormap: JSAMPARRAY ;		(* The color map as a 2-D pixel array *)

    (* State variables: these variables indicate the progress of decompression.
     * The application may examine these but must not modify them.
     *)

    (* Row index of next scanline to be read from jpeg_read_scanlines().
     * Application may use this to control its processing loop, e.g.,
     * "while (output_scanline < output_height)".
     *)
    output_scanline: JDIMENSION ;	(* 0 .. output_height-1  *)

    (* Current input scan number and number of iMCU rows completed in scan.
     * These indicate the progress of the decompressor input side.
     *)
    input_scan_number: int ;	(* Number of SOS markers seen so far *)
    input_iMCU_row: JDIMENSION ;	(* Number of iMCU rows completed *)

    (* The "output scan number" is the notional scan being displayed by the
     * output side.  The decompressor will not allow output scan/row number
     * to get ahead of input scan/row, but it can fall arbitrarily far behind.
     *)
    output_scan_number: int ;	(* Nominal scan number being displayed *)
    output_iMCU_row: JDIMENSION ;	(* Number of iMCU rows read *)

    (* Current progression status.  coef_bits[c][i] indicates the precision
     * with which component c's DCT coefficient i (in zigzag order) is known.
     * It is -1 when no data has yet been received, otherwise it is the point
     * transform (shift) value for the most recent scan of the coefficient
     * (thus, 0 at completion of the progression).
     * This pointer is NULL when reading a non-progressive file.
     *)
    coef_bits: pcoef_bits; (* -1 or current Al value for each coef *)

    (* Internal JPEG parameters --- the application usually need not look at
     * these fields.  Note that the decompressor output side may not use
     * any parameters that can change between scans.
     *)

    (* Quantization and Huffman tables are carried forward across input
     * datastreams when processing abbreviated JPEG datastreams.
     *)

    quant_tbl_ptrs: array [0..NUM_QUANT_TBLS-1] of PJQUANT_TBL;
    (* ptrs to coefficient quantization tables, or NULL if not defined *)

    dc_huff_tbl_ptrs: array [0..NUM_HUFF_TBLS-1] of PJHUFF_TBL;
    ac_huff_tbl_ptrs: array [0..NUM_HUFF_TBLS-1] of PJHUFF_TBL;
    (* ptrs to Huffman coding tables, or NULL if not defined *)

    (* These parameters are never carried across datastreams, since they
     * are given in SOF/SOS markers or defined to be reset by SOI.
     *)

    data_precision: int ;		(* bits of precision in image data *)

    comp_info: pjpeg_component_info;
    (* comp_info[i] describes component that appears i'th in SOF *)

    progressive_mode: boolean ;	(* TRUE if SOFn specifies progressive mode *)
    arith_code: boolean ;		(* TRUE=arithmetic coding, FALSE=Huffman *)

    arith_dc_L: array [0..NUM_ARITH_TBLS-1] of UINT8; (* L values for DC arith-coding tables *)
    arith_dc_U: array [0..NUM_ARITH_TBLS-1] of UINT8; (* U values for DC arith-coding tables *)
    arith_ac_K: array [0..NUM_ARITH_TBLS-1] of UINT8; (* Kx values for AC arith-coding tables *)

    restart_interval: uint ; (* MCUs per restart interval, or 0 for no restart *)

    (* These fields record data obtained from optional markers recognized by
     * the JPEG library.
     *)
    saw_JFIF_marker: boolean ;	(* TRUE iff a JFIF APP0 marker was found *)
    (* Data copied from JFIF marker; only valid if saw_JFIF_marker is TRUE: *)
    JFIF_major_version: UINT8 ;	(* JFIF version number *)
    JFIF_minor_version: UINT8 ;
    density_unit: UINT8 ;		(* JFIF code for pixel size units *)
    X_density: UINT16 ;		(* Horizontal pixel density *)
    Y_density: UINT16 ;		(* Vertical pixel density *)
    saw_Adobe_marker: boolean ;	(* TRUE iff an Adobe APP14 marker was found *)
    Adobe_transform: UINT8 ;	(* Color transform code from Adobe marker *)

    CCIR601_sampling: boolean ;	(* TRUE=first samples are cosited *)

    (* Aside from the specific data retained from APPn markers known to the
     * library, the uninterpreted contents of any or all APPn and COM markers
     * can be saved in a list for examination by the application.
     *)
    marker_list: jpeg_saved_marker_ptr ; (* Head of list of saved markers *)

    (* Remaining fields are known throughout decompressor, but generally
     * should not be touched by a surrounding application.
     *)

    (*
     * These fields are computed during decompression startup
     *)
    max_h_samp_factor: int ;	(* largest h_samp_factor *)
    max_v_samp_factor: int ;	(* largest v_samp_factor *)

    min_DCT_scaled_size: int ;	(* smallest DCT_scaled_size of any component *)

    total_iMCU_rows: JDIMENSION ;	(* # of iMCU rows in image *)
    (* The coefficient controller's input and output progress is measured in
     * units of "iMCU" (interleaved MCU) rows.  These are the same as MCU rows
     * in fully interleaved JPEG scans, but are used whether the scan is
     * interleaved or not.  We define an iMCU row as v_samp_factor DCT block
     * rows of each component.  Therefore, the IDCT output contains
     * v_samp_factor*DCT_scaled_size sample rows of a component per iMCU row.
     *)

    sample_range_limit: PJSAMPLE; (* table for fast range-limiting *)

    (*
     * These fields are valid during any one scan.
     * They describe the components and MCUs actually appearing in the scan.
     * Note that the decompressor output side must not use these fields.
     *)
    comps_in_scan: int ;		(* # of JPEG components in this scan *)
    cur_comp_info: array [0..MAX_COMPS_IN_SCAN-1] of pjpeg_component_info;
    (* *cur_comp_info[i] describes component that appears i'th in SOS *)

    MCUs_per_row: JDIMENSION ;	(* # of MCUs across the image *)
    MCU_rows_in_scan: JDIMENSION ;	(* # of MCU rows in the image *)

    blocks_in_MCU: int ;		(* # of DCT blocks per MCU *)
    MCU_membership: array [0..D_MAX_BLOCKS_IN_MCU-1] of int;
    (* MCU_membership[i] is index in cur_comp_info of component owning *)
    (* i'th block in an MCU *)

    Ss, Se, Ah, Al: int;		(* progressive JPEG parameters for scan *)

    (* This field is shared between entropy decoder and marker parser.
     * It is either zero or the code of a JPEG marker that has been
     * read from the data source, but has not yet been processed.
     *)
    unread_marker: int ;

    (*
     * Links to decompression subobjects (methods, private variables of modules)
     *)
    master: pjpeg_decomp_master;
    main: pjpeg_d_main_controller;
    coef: pjpeg_d_coef_controller;
    post: pjpeg_d_post_controller;
    inputctl: pjpeg_input_controller;
    marker: pjpeg_marker_reader;
    entropy: pjpeg_entropy_decoder;
    idct: pjpeg_inverse_dct;
    upsample: pjpeg_upsampler;
    cconvert: pjpeg_color_deconverter;
    cquantize: pjpeg_color_quantizer;
  end;

  pjpeg_compress_struct = ^jpeg_compress_struct;
  jpeg_compress_struct = record
    err: pjpeg_error_mgr;	(* Error handler module *)
    mem: pjpeg_memory_mgr;	(* Memory manager module *)
    progress: pjpeg_progress_mgr; (* Progress monitor, or NULL if none *)
    client_data: Pointer;		(* Available for use by application *)
    is_decompressor: Boolean;	(* So common code can tell which is which *)
    global_state: int;		(* For checking call sequence validity *)

    (* Destination for compressed data *)
    dest: pjpeg_destination_mgr;

    (* Description of source image --- these fields must be filled in by
     * outer application before starting compression.  in_color_space must
     * be correct before you can even call jpeg_set_defaults().
     *)

    image_width: JDIMENSION;	(* input image width *)
    image_height: JDIMENSION;	(* input image height *)
    input_components: int;		(* # of color components in input image *)
    in_color_space: J_COLOR_SPACE;	(* colorspace of input image *)

    input_gamma: double;		(* image gamma of input image *)

    (* Compression parameters --- these fields must be set before calling
     * jpeg_start_compress().  We recommend calling jpeg_set_defaults() to
     * initialize everything to reasonable defaults, then changing anything
     * the application specifically wants to change.  That way you won't get
     * burnt when new parameters are added.  Also note that there are several
     * helper routines to simplify changing parameters.
     *)

    data_precision: int;		(* bits of precision in image data *)

    num_components: int;		(* # of color components in JPEG image *)
    jpeg_color_space: J_COLOR_SPACE; (* colorspace of JPEG image *)

    comp_info: pjpeg_component_info;
    (* comp_info[i] describes component that appears i'th in SOF *)

    quant_tbl_ptrs: array [0..NUM_QUANT_TBLS-1] of PJQUANT_TBL;
    (* ptrs to coefficient quantization tables, or NULL if not defined *)

    dc_huff_tbl_ptrs: array [0..NUM_HUFF_TBLS-1] of PJHUFF_TBL;
    ac_huff_tbl_ptrs: array [0..NUM_HUFF_TBLS-1] of PJHUFF_TBL;
    (* ptrs to Huffman coding tables, or NULL if not defined *)

    arith_dc_L: array [0..NUM_ARITH_TBLS-1] of UINT8; (* L values for DC arith-coding tables *)
    arith_dc_U: array [0..NUM_ARITH_TBLS-1] of UINT8; (* U values for DC arith-coding tables *)
    arith_ac_K: array [0..NUM_ARITH_TBLS-1] of UINT8; (* Kx values for AC arith-coding tables *)

    num_scans: int;		(* # of entries in scan_info array *)
    scan_info: pjpeg_scan_info; (* script for multi-scan file, or NULL *)
    (* The default value of scan_info is NULL, which causes a single-scan
     * sequential JPEG file to be emitted.  To create a multi-scan file,
     * set num_scans and scan_info to point to an array of scan definitions.
     *)

    raw_data_in: boolean;		(* TRUE=caller supplies downsampled data *)
    arith_code: boolean;		(* TRUE=arithmetic coding, FALSE=Huffman *)
    optimize_coding: boolean;	(* TRUE=optimize entropy encoding parms *)
    CCIR601_sampling: boolean;	(* TRUE=first samples are cosited *)
    smoothing_factor: int;		(* 1..100, or 0 for no input smoothing *)
    dct_method: J_DCT_METHOD;	(* DCT algorithm selector *)

    (* The restart interval can be specified in absolute MCUs by setting
     * restart_interval, or in MCU rows by setting restart_in_rows
     * (in which case the correct restart_interval will be figured
     * for each scan).
     *)
    restart_interval: uint; (* MCUs per restart, or 0 for no restart *)
    restart_in_rows: int;		(* if > 0, MCU rows per restart interval *)

    (* Parameters controlling emission of special markers. *)

    write_JFIF_header: boolean;	(* should a JFIF marker be written? *)
    JFIF_major_version: UINT8;	(* What to write for the JFIF version number *)
    JFIF_minor_version: UINT8;
    (* These three values are not used by the JPEG code, merely copied *)
    (* into the JFIF APP0 marker.  density_unit can be 0 for unknown, *)
    (* 1 for dots/inch, or 2 for dots/cm.  Note that the pixel aspect *)
    (* ratio is defined by X_density/Y_density even when density_unit=0. *)
    density_unit: UINT8;		(* JFIF code for pixel size units *)
    X_density: UINT16;		(* Horizontal pixel density *)
    Y_density: UINT16;		(* Vertical pixel density *)
    write_Adobe_marker: boolean;	(* should an Adobe marker be written? *)

    (* State variable: index of next scanline to be written to
     * jpeg_write_scanlines().  Application may use this to control its
     * processing loop, e.g., "while (next_scanline < image_height)".
     *)

    next_scanline: JDIMENSION;	(* 0 .. image_height-1  *)

    (* Remaining fields are known throughout compressor, but generally
     * should not be touched by a surrounding application.
     *)

    (*
     * These fields are computed during compression startup
     *)
    progressive_mode: boolean;	(* TRUE if scan script uses progressive mode *)
    max_h_samp_factor: int;	(* largest h_samp_factor *)
    max_v_samp_factor: int;	(* largest v_samp_factor *)

    total_iMCU_rows: JDIMENSION;	(* # of iMCU rows to be input to coef ctlr *)
    (* The coefficient controller receives data in units of MCU rows as defined
     * for fully interleaved scans (whether the JPEG file is interleaved or not).
     * There are v_samp_factor * DCTSIZE sample rows of each component in an
     * "iMCU" (interleaved MCU) row.
     *)

    (*
     * These fields are valid during any one scan.
     * They describe the components and MCUs actually appearing in the scan.
     *)
    comps_in_scan: int;		(* # of JPEG components in this scan *)
    cur_comp_info: array [0..MAX_COMPS_IN_SCAN-1] of pjpeg_component_info;
    (* *cur_comp_info[i] describes component that appears i'th in SOS *)

    MCUs_per_row: JDIMENSION;	(* # of MCUs across the image *)
    MCU_rows_in_scan: JDIMENSION;	(* # of MCU rows in the image *)

    blocks_in_MCU: int;		(* # of DCT blocks per MCU *)
    MCU_membership: array [0..C_MAX_BLOCKS_IN_MCU-1] of int;
    (* MCU_membership[i] is index in cur_comp_info of component owning *)
    (* i'th block in an MCU *)

    Ss, Se, Ah, Al: int;		(* progressive JPEG parameters for scan *)

    (*
     * Links to compression subobjects (methods and private variables of modules)
     *)
    master: pjpeg_comp_master;
    main: pjpeg_c_main_controller;
    prep: pjpeg_c_prep_controller;
    coef: pjpeg_c_coef_controller;
    marker: pjpeg_marker_writer;
    cconvert: pjpeg_color_converter;
    downsample: pjpeg_downsampler;
    fdct: pjpeg_forward_dct;
    entropy: pjpeg_entropy_encoder;
    script_space: pjpeg_scan_info; (* workspace for jpeg_simple_progression *)
    script_space_size: int;
  end;

  jpeg_error_mgr = record
    (* Error exit handler: does not return to caller *)
    error_exit: procedure (CInfo: j_common_ptr); cdecl;
    (* Conditionally emit a trace or warning message *)
    emit_message:  procedure (CInfo: j_common_ptr; msg_level: int); cdecl;
    (* Routine that actually outputs a trace or error message *)
    output_message: procedure (CInfo: j_common_ptr); cdecl;
    (* Format a message string for the most recent JPEG error or message *)
    format_message:  procedure (CInfo: j_common_ptr; Buffer: PChar); cdecl;
    (* Reset error state variables at start of a new image *)
    reset_error_mgr: JMETHOD;

    (* The message ID code and any parameters are saved here.
     * A message can have one string parameter or up to 8 int parameters.
     *)
    msg_code: int;
    msg_param: record
      case Integer of
        0: (i: array [0..7] of int);
        1: (s: array [0..JMSG_STR_PARM_MAX-1] of Char);
    end;
    (* Standard state variables for error facility *)

    trace_level: int ;		(* max msg_level that will be displayed *)

    (* For recoverable corrupt-data errors, we emit a warning message,
     * but keep going unless emit_message chooses to abort.  emit_message
     * should count warnings in num_warnings.  The surrounding application
     * can check for bad data by seeing if num_warnings is nonzero at the
     * end of processing.
     *)
    num_warnings: long ;		(* number of corrupt-data warnings *)

    (* These fields point to the table(s) of error message strings.
     * An application can change the table pointer to switch to a different
     * message list (typically, to change the language in which errors are
     * reported).  Some applications may wish to add additional error codes
     * that will be handled by the JPEG library error mechanism; the second
     * table pointer is used for this purpose.
     *
     * First table includes all errors generated by JPEG library itself.
     * Error code 0 is reserved for a "no such error string" message.
     *)
    jpeg_message_table: PPChar; (* Library errors *)
    last_jpeg_message: int ;    (* Table contains strings 0..last_jpeg_message *)
    (* Second table can be added by application (see cjpeg/djpeg for example).
     * It contains strings numbered first_addon_message..last_addon_message.
     *)
    addon_message_table: PPChar; (* Non-library errors *)
    first_addon_message: int ;	(* code for first string in addon table *)
    last_addon_message: int ;	(* code for last string in addon table *)
  end;

  jpeg_source_mgr = record
    next_input_byte: PJOCTET; // => next byte to read from buffer
    bytes_in_buffer: size_t;	// # of bytes remaining in buffer

    init_source: procedure (var cinfo: jpeg_decompress_struct); cdecl;
    fill_input_buffer: function (var cinfo: jpeg_decompress_struct ): Boolean; cdecl;
    skip_input_data: procedure (var cinfo: jpeg_decompress_struct; num_bytes: long); cdecl;
    resync_to_restart: function (var cinfo: jpeg_decompress_struct; desired: int): Boolean; cdecl;
    term_source: procedure (var cinfo: jpeg_decompress_struct); cdecl;
  end;

  jpeg_destination_mgr = record
    next_output_byte: PJOCTET;	(* => next byte to write in buffer *)
    free_in_buffer: size_t;	(* # of byte spaces remaining in buffer *)

    init_destination: procedure (var cinfo: jpeg_compress_struct); cdecl;
    empty_output_buffer: function (var cinfo: jpeg_compress_struct): Boolean; cdecl;
    term_destination: procedure (var cinfo: jpeg_compress_struct); cdecl;
  end;

  jpeg_scan_info = record
    comps_in_scan: int;		(* number of components encoded in this scan *)
    component_index: array [0..MAX_COMPS_IN_SCAN-1] of int; (* their SOF/comp_info[] indexes *)
    Ss, Se: int;			(* progressive JPEG spectral selection parms *)
    Ah, Al: int;			(* progressive JPEG successive approx. parms *)
  end;

  jpeg_memory_mgr = record
    (* Method pointers *)
    alloc_small: function(cinfo: j_common_ptr; pool_id: int; sizeofobject: size_t): Pointer; cdecl;
    alloc_large: JMETHOD;
    alloc_sarry: JMETHOD;
    alloc_barray: JMETHOD;
    request_virt_sarray: JMETHOD;
    request_virt_barray: JMETHOD;
    realize_virt_arrays: JMETHOD;
    access_virt_sarray: JMETHOD;
    access_virt_barray: JMETHOD;
    free_pool: JMETHOD;
    self_destruct: JMETHOD;
{    JMETHOD(void FAR *, alloc_large, (j_common_ptr cinfo, int pool_id,
               size_t sizeofobject));
    JMETHOD(JSAMPARRAY, alloc_sarray, (j_common_ptr cinfo, int pool_id,
               JDIMENSION samplesperrow,
               JDIMENSION numrows));
    JMETHOD(JBLOCKARRAY, alloc_barray, (j_common_ptr cinfo, int pool_id,
                JDIMENSION blocksperrow,
                JDIMENSION numrows));
    JMETHOD(jvirt_sarray_ptr, request_virt_sarray, (j_common_ptr cinfo,
                int pool_id,
                boolean pre_zero,
                JDIMENSION samplesperrow,
                JDIMENSION numrows,
                JDIMENSION maxaccess));
    JMETHOD(jvirt_barray_ptr, request_virt_barray, (j_common_ptr cinfo,
                int pool_id,
                boolean pre_zero,
                JDIMENSION blocksperrow,
                JDIMENSION numrows,
                JDIMENSION maxaccess));
    JMETHOD(void, realize_virt_arrays, (j_common_ptr cinfo));
    JMETHOD(JSAMPARRAY, access_virt_sarray, (j_common_ptr cinfo,
               jvirt_sarray_ptr ptr,
               JDIMENSION start_row,
               JDIMENSION num_rows,
               boolean writable));
    JMETHOD(JBLOCKARRAY, access_virt_barray, (j_common_ptr cinfo,
                jvirt_barray_ptr ptr,
                JDIMENSION start_row,
                JDIMENSION num_rows,
                boolean writable));
    JMETHOD(void, free_pool, (j_common_ptr cinfo, int pool_id));
    JMETHOD(void, self_destruct, (j_common_ptr cinfo));}

    (* Limit on memory allocation for this JPEG object.  (Note that this is
     * merely advisory, not a guaranteed maximum; it only affects the space
     * used for virtual-array buffers.)  May be changed by outer application
     * after creating the JPEG object.
     *)
    max_memory_to_use: long;

    (* Maximum allocation request accepted by alloc_large. *)
    max_alloc_chunk: long;
  end;

const
  jpeglib = 'libjpeg.dll';

function jpeg_std_error(err: pjpeg_error_mgr): pjpeg_error_mgr; cdecl; external jpeglib;
procedure jpeg_CreateDecompress(var cinfo: jpeg_decompress_struct; version: int; structsize: size_t); cdecl; external jpeglib;
function jpeg_read_header(var cinfo: jpeg_decompress_struct; require_image: Boolean): int; cdecl; external jpeglib;
function jpeg_resync_to_restart(var cinfo: jpeg_decompress_struct; desired: int): Boolean; cdecl; external jpeglib;
function jpeg_start_decompress(var cinfo: jpeg_decompress_struct): Boolean; cdecl; external jpeglib;
function jpeg_read_scanlines(var cinfo: jpeg_decompress_struct; scanlines: JSAMPARRAY;
	max_lines: JDIMENSION): JDIMENSION; cdecl; external jpeglib;
function jpeg_finish_decompress(var cinfo: jpeg_decompress_struct): Boolean; cdecl; external jpeglib;
procedure jpeg_destroy_decompress(var cinfo: jpeg_decompress_struct); cdecl; external jpeglib;
procedure jpeg_CreateCompress(var cinfo: jpeg_compress_struct; version: int; structsize: size_t); cdecl; external jpeglib;
procedure jpeg_set_defaults(var cinfo: jpeg_compress_struct); cdecl; external jpeglib;
procedure jpeg_set_quality(var cinfo: jpeg_compress_struct; quality: int; force_baseline: boolean); cdecl; external jpeglib;
procedure jpeg_start_compress(var cinfo: jpeg_compress_struct; write_all_tables: boolean); cdecl; external jpeglib;
function jpeg_write_scanlines(var cinfo: jpeg_compress_struct; scanlines: JSAMPARRAY;
	num_lines: JDIMENSION): JDIMENSION; cdecl; external jpeglib;
function jpeg_finish_compress(var cinfo: jpeg_compress_struct): Boolean; cdecl; external jpeglib;
procedure jpeg_destroy_compress(var cinfo: jpeg_compress_struct); cdecl; external jpeglib;

procedure jpeg_create_decompress(var cinfo: jpeg_decompress_struct);
procedure jpeg_create_compress(var cinfo: jpeg_compress_struct);

procedure ERREXIT(CInfo: j_common_ptr; Code: J_MESSAGE_CODE);
procedure WARNMS(CInfo: j_common_ptr; Code: J_MESSAGE_CODE);

implementation

procedure jpeg_create_decompress(var cinfo: jpeg_decompress_struct);
begin
  jpeg_CreateDecompress(cinfo,JPEG_LIB_VERSION,SizeOf(jpeg_decompress_struct));
end;

procedure jpeg_create_compress(var cinfo: jpeg_compress_struct);
begin
  jpeg_CreateCompress(cinfo,JPEG_LIB_VERSION,SizeOf(jpeg_compress_struct));
end;

procedure ERREXIT(CInfo: j_common_ptr; Code: J_MESSAGE_CODE);
begin
  CInfo.err.msg_code := Ord(Code);
  CInfo.err.error_exit(CInfo);
end;

procedure WARNMS(CInfo: j_common_ptr; Code: J_MESSAGE_CODE);
begin
  CInfo.err.msg_code := Ord(Code);
  CInfo.err.emit_message(CInfo,-1);
end;

end.
